SystemOrganization addCategory: #'Seaside-Tests-Flow-Functional'!
SystemOrganization addCategory: #'Seaside-Tests-Flow-Unit'!

WAFunctionalTest subclass: #WAFlowClosureFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Flow-Functional'!

!WAFlowClosureFunctionalTest methodsFor: 'actions' stamp: 'lr 2/28/2008 09:25'!
ensure
	[ self go ] ensure: [ self inform: 'ensure' ]! !

!WAFlowClosureFunctionalTest methodsFor: 'actions' stamp: 'lr 2/28/2008 09:28'!
go
	(1 to: 3) do: [ :index | self inform: index ]! !

!WAFlowClosureFunctionalTest methodsFor: 'rendering' stamp: 'lr 1/25/2010 23:32'!
renderContentOn: html
	html paragraph: 'The following two anchors should trigger a 3 step flow. Backtracking and spawning of windows should properly work.'.
	html paragraph: [
		html anchor
			callback: [ self go ];
			with: 'Go' ].

	html paragraph 
		style: 'color: red; font-weight: bold';
		with: 'WARNING: FOLLOWING SECTION IS FOR DEVELOPERS ONLY'.
	html paragraph: [
		html text: 'The "Go with ensure" test is '.
		html span style: 'color:red; font-weight:bold'; with: 'expected to fail'.
		html text: ' right now, as the ensure fires during rendering. The ensure does not survive across continuations at the present time.' ].
	html paragraph: [
		html anchor
			callback: [ self ensure ];
			with: 'Go with ensure' ]! !

WAFunctionalTest subclass: #WAFlowFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Flow-Functional'!

!WAFlowFunctionalTest methodsFor: 'actions' stamp: 'pmm 6/26/2011 13:32'!
goAnchors
	
	1 to: 5 do: [ :each | 
		| component |
		component := WAComponent new.
		component addMessage: [ :html | 
			html anchor
				callback: [ component answer ];
				with: each greaseString, ': ', self stackDepth greaseString ] fixCallbackTemps.
		self call: component ]! !

!WAFlowFunctionalTest methodsFor: 'actions' stamp: 'pmm 6/26/2011 13:32'!
goButtons
	1 to: 5 do: [ :each |
		self inform: each greaseString, ': ', self stackDepth greaseString ]! !

!WAFlowFunctionalTest methodsFor: 'rendering' stamp: 'lr 5/22/2007 18:10'!
renderContentOn: html
	html paragraph: 'The following two anchors should trigger flows with 5 steps each. The stack should neither grow nor shrink. Backtracking and spawning of windows should properly work.'.
	html paragraph: [
		html anchor
			callback: [ self goAnchors ];
			with: 'go anchors'.
		html break.
		html anchor
			callback: [ self goButtons ];
			with: 'go buttons' ]! !

!WAFlowFunctionalTest methodsFor: 'private' stamp: 'jf 9/30/2009 00:19'!
stackDepth
	^ GRPlatform current stackDepth! !

WAFunctionalTest subclass: #WAFlowRenderingCallFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Flow-Functional'!

!WAFlowRenderingCallFunctionalTest methodsFor: 'rendering' stamp: 'jf 10/28/2008 10:15'!
renderContentOn: html
	html paragraph: [
		html anchor
			callback: [ self call: WACallDuringRenderTestComponent new ];
			with: 'This link'.
		html text: ' will call a Component which attempts to do a #call: in its #renderContentOn: method. This is not allowed and should trigger a descriptive error. With WAWalkbackErrorHandler enabled, the output should explain to the user the likely cause of the problem.' ]! !

WAComponent subclass: #WACallDuringRenderTestComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Flow-Functional'!

!WACallDuringRenderTestComponent methodsFor: 'rendering' stamp: 'jf 10/28/2008 10:13'!
renderContentOn: html
	self call: WAMiniCalendar new! !

WAExceptionFunctionalTest subclass: #WAFlowErrorFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Flow-Functional'!

!WAFlowErrorFunctionalTest methodsFor: 'rendering' stamp: 'jf 2/21/2009 15:19'!
renderErrorWithCallOn: html 
	html heading: 'Error in a called component'.
	html paragraph: 'A message should be displayed. Once you click the button, behaviour should be identical to the Error case above without a call. If not, we may have a problem with continuations holding onto the request context.'.
	html anchor
		callback: [ self inform: 'Once you close this, an error will be raised.'. self raiseError ];
		with: 'Raise error'! !

!WAFlowErrorFunctionalTest methodsFor: 'rendering' stamp: 'jf 2/21/2009 15:20'!
renderPartsOn: html
	self renderErrorOn: html.
	self renderErrorWithCallOn: html! !

TestCase subclass: #WAFlowPlatformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Flow-Unit'!

!WAFlowPlatformTest methodsFor: 'private' stamp: 'jf 1/27/2009 14:21'!
evaluateCallbackContinuation: aContinuation with: anObject
	| callback |
	callback := WAActionCallback new.
	callback block: [ aContinuation value: anObject ].
	[ callback evaluateWithArgument: nil ]
		on: WARenderNotification do: [ :n | ]! !

!WAFlowPlatformTest methodsFor: 'tests' stamp: 'jf 1/27/2009 14:20'!
testSuspendCallbackDo
	| continuation result |
	continuation := nil.
	self withCallbackContinuationDo: [ :cc | continuation := cc ] resultBlock: [ :r | result := r ].
	self assert: continuation notNil.
	self evaluateCallbackContinuation: continuation with: 123.
	self assert: result = 123! !

!WAFlowPlatformTest methodsFor: 'private' stamp: 'jf 2/9/2010 01:31'!
withCallbackContinuationDo: ccBlock resultBlock: resultBlock 
	| callback |
	callback := WAActionCallback new.
	callback block: [ resultBlock value: (GRPlatform current seasideSuspendFlowDo: ccBlock) ].
	[ callback evaluateWithArgument: nil ] 
		on: WARenderNotification
		do: [ :n |  ]! !

WADelegationTask subclass: #WAFlowDelegationTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Flow-Functional'!

!WAFlowDelegationTask methodsFor: 'running' stamp: 'jf 12/19/2009 02:39'!
go
	self call: component1.
	self call: component2.! !

!GRPackage class methodsFor: '*seaside-tests-flow' stamp: 'lr 2/17/2010 15:13'!
seasideTestsFlow
	^ self new
		name: 'Seaside-Tests-Flow';
		description: 'Functional tests for Seaside-Flow.';
		addDependency: 'Seaside-Flow';
		addDependency: 'Seaside-Tests-Functional';
		url: #seasideUrl;
		yourself! !

WADelegationFunctionalTest subclass: #WAFlowDelegationFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Flow-Functional'!

!WAFlowDelegationFunctionalTest methodsFor: 'initialization' stamp: 'jf 12/19/2009 02:40'!
initialize
	super initialize.
	task := WAFlowDelegationTask new! !

!WAFlowDelegationFunctionalTest methodsFor: 'rendering' stamp: 'jf 12/19/2009 02:41'!
renderContentOn: html
	html paragraph: 'This test is just like WADelegationFunctionalTest, but it uses Flow/Continuations.'.
	super renderContentOn: html! !

WAFunctionalTaskTest subclass: #WAFlowConvenienceFunctionalTest
	instanceVariableNames: 'cheese'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Flow-Functional'!

!WAFlowConvenienceFunctionalTest methodsFor: 'controlling' stamp: 'lr 10/28/2007 14:42'!
chooseCheese
	cheese := self
		chooseFrom: #('Greyerzer' 'Tilsiter' 'Sbrinz')
		caption: 'What''s your favorite Cheese?'.
	cheese isNil ifTrue: [ self chooseCheese ]! !

!WAFlowConvenienceFunctionalTest methodsFor: 'controlling' stamp: 'lr 7/25/2011 20:04'!
confirmCheese
	^ self confirm: 'Is ' , cheese , ' your favorite cheese?'! !

!WAFlowConvenienceFunctionalTest methodsFor: 'running' stamp: 'pmm 6/30/2007 12:24'!
go
	[ self chooseCheese.
	  self confirmCheese ] whileFalse.
	self informCheese! !

!WAFlowConvenienceFunctionalTest methodsFor: 'controlling' stamp: 'lr 10/28/2007 14:42'!
informCheese
	self inform: 'Your favorite cheese is ', cheese, '.'! !

!WAFlowConvenienceFunctionalTest methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:04'!
states
	^ Array with: self! !
